#/* Copyright 1998-2011 Research Foundation State University of New York */
#
#/* This file is part of QuB.                                            */
#
#/* QuB is free software; you can redistribute it and/or modify          */
#/* it under the terms of the GNU General Public License as published by */
#/* the Free Software Foundation, either version 3 of the License, or    */
#/* (at your option) any later version.                                  */
#
#/* QuB is distributed in the hope that it will be useful,               */
#/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
#/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
#/* GNU General Public License for more details.                         */
#
#/* You should have received a copy of the GNU General Public License,   */
#/* named LICENSE.txt, in the QuB program directory.  If not, see        */
#/* <http://www.gnu.org/licenses/>.                                      */

from math import *
from string import join
import re

def MissingName(msg):
 m = re.search("'([^']+)'", msg)
 if not m:
  raise NameError, msg
 return m.group(1)

def ParseCustomEqn(eqn):
 args = ['x']
 valid = 0
 func = lambda : 0.0

 while not valid:
  try:
   func = eval( 'lambda ' + join(args, ',') + ': ' + eqn )
   fval = float( apply( func, map(lambda z:1.0, range(len(args))) ) )
   valid = 1
  except NameError, msg:
   args.append( MissingName(str(msg)) )

 return func, args
